﻿using System;
using System.Configuration;

namespace TechFest.SharePoint.JQuery.Utilities
{
    public static class ClientSideArtifacts
    {
        #region helpers

        private static string revision = "1.0.0";

        private static string getAppSettingValue(string appSettingKey, string defaultValue) {
            return (
                String.Format("{0}?rev={1}", 
                    (String.IsNullOrEmpty(ConfigurationManager.AppSettings[appSettingKey])
                        ? defaultValue : ConfigurationManager.AppSettings[appSettingKey].ToString()),
                    revision)
            );
        }

        #endregion  


        #region jQuery

        private static string jqueryKey = "jQuery";
        private static string jqueryFile = "/_layouts/TechFest.SharePoint.JQuery/Common/jquery-1.3.2.min.js";

        /// <summary>
        /// JavaScript: jQuery script registration key
        /// </summary>
        public static string JQueryScriptKey
        {
            get
            {
                return (getAppSettingValue("JQueryKey", jqueryKey));
            }
        }

        /// <summary>
        /// JavaScript: jQuery file URL
        /// </summary>
        public static string JQueryScriptFile
        {
            get
            {
                return (getAppSettingValue("JQueryFile", jqueryFile));
            }
        }

        #endregion


        #region TabSwitcherWebPart

        private static string tabSwitcherWebPartScriptKey = "TabSwitcherWebPart";
        private static string tabSwitcherWebPartScriptFile = "/_layouts/TechFest.SharePoint.JQuery/TabSwitcherWebPart/TabSwitcherWebPart.js";
        private static string tabSwitcherWebPartCssKey = "TabSwitcherWebPartCss";
        private static string tabSwitcherWebPartCssFile = "/_layouts/TechFest.SharePoint.JQuery/TabSwitcherWebPart/TabSwitcherWebPart.css";

        /// <summary>
        /// JavaScript: TabSwitcherWebPart script registration key
        /// </summary>
        public static string TabSwitcherWebPartScriptKey
        {
            get
            {
                return (getAppSettingValue("TabSwitcherWebPartScriptKey", tabSwitcherWebPartScriptKey));
            }
        }

        /// <summary>
        /// JavaScript: TabSwitcherWebPart script file URL
        /// </summary>
        public static string TabSwitcherWebPartScriptFile
        {
            get
            {
                return (getAppSettingValue("TabSwitcherWebPartScriptFile", tabSwitcherWebPartScriptFile));
            }
        }

        /// <summary>
        /// CSS: TabSwitcherWebPart CSS registration key
        /// </summary>
        public static string TabSwitcherWebPartCssKey
        {
            get
            {
                return (getAppSettingValue("TabSwitcherWebPartCssKey", tabSwitcherWebPartCssKey));
            }
        }

        /// <summary>
        /// CSS: TabSwitcherWebPart CSS file URL
        /// </summary>
        public static string TabSwitcherWebPartCssFile
        {
            get
            {
                return (getAppSettingValue("TabSwitcherWebPartCssFile", tabSwitcherWebPartCssFile));
            }
        }
        #endregion


        #region EqualHeightWebPart

        private static string equalHeightWebPartScriptKey = "EqualHeightWebPart";
        private static string equalHeightWebPartScriptFile = "/_layouts/TechFest.SharePoint.JQuery/EqualHeightWebPart/EqualHeightWebPart.js";

        /// <summary>
        /// JavaScript: EqualHeightWebPart script registration key
        /// </summary>
        public static string EqualHeightWebPartScriptKey
        {
            get
            {
                return (getAppSettingValue("EqualHeightWebPartScriptKey", equalHeightWebPartScriptKey));
            }
        }

        /// <summary>
        /// JavaScript: EqualHeightWebPart script file URL
        /// </summary>
        public static string EqualHeightWebPartScriptFile
        {
            get
            {
                return (getAppSettingValue("EqualHeightWebPartScriptFile", equalHeightWebPartScriptFile));
            }
        }

        #endregion


    }
}
